r73: mali cleanup u manualu
[carnet-tools-cn.git] / functions.sh
index f3124da..28877c5 100644 (file)
@@ -17,13 +17,13 @@ cp_get_ifaddr() {
   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
     echo "cp_get_ifaddr: $interface: No such interface" 1>&2
     CP_ECHO_RETURN="$echo_return"
-    return 1
+    return 2
   fi
 
   ifaddr="`/sbin/ifconfig $interface | awk '/inet/{ printf("%s\n",substr($2,index($2,":")+1)) }'`"
 
   if [ -z $ifaddr ]; then
-    echo "cp_get_ifaddr: $interface: No such ipaddress" 1>&2
+    echo "cp_get_ifaddr: $interface: No ip address found" 1>&2
     CP_ECHO_RETURN="$echo_return"
     return 1
   fi
@@ -58,7 +58,7 @@ cp_get_ifmask() {
   ifmask="`/sbin/ifconfig $interface | awk '/Mask/{if($3~/Mask/)a=$3;else if ($4~/Mask/)a=$4;printf ("%s\n", substr(a,index(a,":")+1))}'`"
 
   if [ -z "$ifmask" ]; then
-    echo "cp_get_ifmask: $interface: No such netmask" 1>&2
+    echo "cp_get_ifmask: $interface: No netmask found" 1>&2
     CP_ECHO_RETURN="$echo_return"
     return 1
   fi
@@ -83,7 +83,7 @@ cp_get_ifdefault() {
     addr) RET=`route -n | awk '/^0.0.0.0/{print $2}'` ;;
     *)    echo "cp_get_ifdefault: Argument required (dev or addr)" >&2 ;;
   esac
-  [ -z "$RET" -a "$1" -a "$CP_VERBOSE" ] && echo "cp_get_ifdefault: No default route" >&2
+  [ -z "$RET" -a "$1" ] && echo "cp_get_ifdefault: No default route" >&2
   [ -z "$echo_return" ] || echo $RET
   CP_ECHO_RETURN="$echo_return"
   [ -z "$RET" ] && return 1
@@ -114,14 +114,14 @@ cp_get_netaddr() {
   cp_get_ifaddr "$interface"
   ipaddress="$RET"
   if [ -z $ipaddress ]; then
-    echo "cp_get_netaddr: $interface: No such ipaddress" 1>&2
+    echo "cp_get_netaddr: $interface: No IP address found" 1>&2
     CP_ECHO_RETURN="$echo_return"
     return 1
   fi
   cp_get_ifmask "$interface"
   netmask="$RET"
   if [ -z $netmask ]; then
-    echo "cp_get_netaddr: $interface: No such netmask" 1>&2
+    echo "cp_get_netaddr: $interface: No netmask found" 1>&2
     CP_ECHO_RETURN="$echo_return"
     return 1
   fi
@@ -137,32 +137,54 @@ cp_get_netaddr() {
   CP_ECHO_RETURN="$echo_return"
 }
 
+cp_check_and_backup() {
+  cp_backup_conffile -r "$@"
+}
+
 # by ico, Tue, 15 Mar 2005 14:04:21 +0100
 cp_backup_conffile() {
   [ "$CP_SCRIPT_DEBUG" ] && set -vx
-  local file_bak
-
+  local file_bak check did
+  
+  if [ "x$1" = "x-r" ]; then
+    check=1
+    shift
+  fi
   if [ -z "$1" ]; then
     return 1
   fi
   if [ ! -f "$1" ]; then
     echo "cp_backup_conffile: $1: No such file" 1>&2
-    return 1
+    return 2
+  fi
+  if [ -z "$2" ]; then
+    file_bak="/var/backups/`basename $1`.bak"
+  else
+    file_bak="/var/backups/`basename $2`.bak"
   fi
 
-  file_bak="/var/backups/`basename $1`.bak"
-
-  if [ ! -f $file_bak ]; then
-    cp -pf "$1" $file_bak
+  if [ ! -f "$file_bak" ]; then
+    cp -pf "$1" "$file_bak"
+    did=1
   else
-    if ! cmp -s "$1" $file_bak; then
-      /usr/bin/savelog -p -c 7 $file_bak > /dev/null 2> /dev/null
-      cp -pf $1 $file_bak
+    if ! cmp -s "$1" "$file_bak"; then
+      /usr/bin/savelog -p -c 7 "$file_bak" > /dev/null 2> /dev/null
+      cp -pf "$1" "$file_bak"
+      did=1
     fi
   fi
+
+  [ -z "$check" ] && return 0
+
+  if [ "$check" -a ! "$did" ]; then
+    return 3
+  else
+    return 0
+  fi
 }
 
 # by jelly, Tue, 15 Mar 2005 14:04:21 +0100
+# modified by ico, Mon,  6 Jun 2005 11:58:08 +0200
 # A sed wrapper, to use instead of perl -pi -e
 #  - relatively safe in-place s///g
 #  - takes care of symlinks and ownership
@@ -170,7 +192,10 @@ cp_backup_conffile() {
 #
 cp_check_and_sed() {
   [ "$CP_SCRIPT_DEBUG" ] && set -vx
-  local s sedcmd ret i
+  local s sedcmd grepret ret i
+  if [ -z "$3" ]; then
+    return 1
+  fi
   s="$1"
   shift
   sedcmd="$1"
@@ -179,11 +204,17 @@ cp_check_and_sed() {
   for i in "$@"
   do
     [ -e "$i" ]        || continue
-    if egrep -q "$s" "$i"; then
+    if ! egrep -q "$s" "$i"; then
+      grepret=1
       continue
     fi
     [ -h "$i" ]        && i=$(readlink -f "$i")
     sed "$sedcmd" "$i" > "$i.dpkg-tmp"
+    if [ $? -ne 0 ]; then
+      rm "$i.dpkg-tmp"
+      echo "cp_check_and_sed: Problem with sed" 1>&2
+      return 5
+    fi
     if ! cmp -s "$i" "$i.dpkg-tmp" 2>&1 >/dev/null; then
       cp_mv "$i.dpkg-tmp" "$i"
     else
@@ -191,6 +222,7 @@ cp_check_and_sed() {
     fi
     ret=0
   done
+  [ "$ret" -eq 2 -a "$grepret" ] && ret=1 || true
   return $ret
 }
 
@@ -255,6 +287,7 @@ cp_mv () {
   fi
   mv "$new" "$old"
 }
+
 # by ddzeko, Mon, 21 Mar 2005 13:35:42 +0100
 cp_yes_no () {
   [ "$CP_SCRIPT_DEBUG" ] && set -vx
@@ -266,7 +299,7 @@ cp_yes_no () {
   # check to prevent user from using this when debconf is active
   # (it would break communication with its backend - uses stdin/out)
   if [ "$DEBCONF_REDIR" ]; then
-    echo "cn_yes_no: debconf redirection detected" >&2
+    echo "cp_yes_no: debconf redirection detected" >&2
     return 1
   fi
 
@@ -297,9 +330,17 @@ cp_yes_no () {
 # --> that's why we wrap the db_get call to return unset RET variable
 #     instead of some gibberish error message that our script does
 #     not expect
-cp_db_get_wrap() {
+cp_db_get() {
   local var
   var="$1"
+  
+  # check to prevent user from using this before activating debconf
+  # confmodule needs to be loaded before accessing db_* functions
+  if [ -z "$DEBCONF_REDIR" ]; then
+    echo "cp_db_get: debconf not activated!" >&2
+    return 1
+  fi
   if ! db_get "$var"; then
     case "$RET" in
         *doesn\'t\ exist)
@@ -312,3 +353,56 @@ cp_db_get_wrap() {
   fi
 }
 
+# by ico, Wed, 20 Apr 2005 21:09:54 +0200
+cp_get_ldap_suffix() {
+  local echo_return
+  echo_return="$CP_ECHO_RETURN" # since we're making our own calls
+  # in our own way we need to set CP_ECHO_RETURN the way we want it
+  # but preserving initial state so it could be used afterwards
+  CP_ECHO_RETURN=""
+
+  [ "$CP_SCRIPT_DEBUG" ] && set -vx
+
+  if [ ! -f /etc/ldap/slapd.conf ]; then
+    echo "cp_get_ldap_suffix: /etc/ldap/slapd.conf: No such file" >&2
+    return 2
+  fi
+  
+  RET="`awk  '/^suffix/      { exit }
+              END            { gsub(/"/, "", $2); print $2 }' \
+            < /etc/ldap/slapd.conf`"
+
+  if [ "`echo $RET | sed 's/,/ /g' | wc -w`" -gt 2 ]; then
+    RET=""
+    echo "cp_get_ldap_suffix: Invalid LDAP suffix in /etc/ldap/slapd.conf" >&2
+    return 2
+  fi
+    
+  [ -z "$RET" ] && echo "cp_get_ldap_suffix: No LDAP suffix in /etc/ldap/slapd.conf" >&2
+  [ -z "$echo_return" ] || echo $RET
+  CP_ECHO_RETURN="$echo_return"
+}
+
+# by ico, Wed, 20 Apr 2005 21:09:54 +0200
+cp_get_ldap_realm() {
+  local echo_return
+  echo_return="$CP_ECHO_RETURN" # since we're making our own calls
+  # in our own way we need to set CP_ECHO_RETURN the way we want it
+  # but preserving initial state so it could be used afterwards
+  CP_ECHO_RETURN=""
+
+  [ "$CP_SCRIPT_DEBUG" ] && set -vx
+
+  if [ ! -f /etc/ldap/slapd.conf ]; then
+    echo "cp_get_ldap_realm: /etc/ldap/slapd.conf: No such file" >&2
+    return 2
+  fi
+  cp_get_ldap_suffix || true
+  RET="`echo $RET | awk -F, '{print $1}' | awk -F= '{print $2}'`"
+
+  [ -z "$RET" ] && echo "cp_get_ldap_realm: No LDAP REALM in /etc/ldap/slapd.conf" >&2
+  [ -z "$echo_return" ] || echo $RET
+  CP_ECHO_RETURN="$echo_return"
+}
+